<?php

/*------------------------------------------------------------------------
# com_affiliatetracker - Affiliate Tracker for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2012 JoomlaInvoices.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.JoomlaInvoices.com
# Technical Support:	Forum - http://www.JoomlaFinances.com/forum
-------------------------------------------------------------------------*/

/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgAffiliatesPayment_offline extends JPlugin {


	var $_payment_type = 'payment_offline';


	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		$this->loadLanguage( '', JPATH_ADMINISTRATOR );

		//load the translation
		$this->loadLanguage( );
	}


	function _process()
	{
		return true;
	}

	function update_payment($payment){

		$db = JFactory::getDBO();

		$query = 	' UPDATE #__affiliate_tracker_payments SET '.
					' payment_type =  "'.$payment->payment_type.'", '.
					' payment_datetime =  NOW(), '.
					' payment_details =  "'.$payment->payment_details.'", '.
					' payment_status =  '.$payment->payment_status.' '.
					' WHERE id = '.$payment->id .
					' LIMIT 1 ';

		$db->setQuery($query);
		$db->query();

	}

	function onRenderPaymentOptions( $row, $user_id )
	{
		/*
		 * get all necessary data and prepare vars for assigning to the template
		 */

		$user = JFactory::getUser($user_id);

		$payment_options = AffiliateHelper::getUserPaymentOptions($row->user_id);

		$vars = new JObject();

		$vars->name = $payment_options->payment_offline->name ;
		$vars->bankname = $payment_options->payment_offline->bankname ;
		$vars->iban = $payment_options->payment_offline->iban ;
		$vars->swift = $payment_options->payment_offline->swift ;

		$html = $this->_getLayout('form', $vars);

		$text = array();
		$text[] = $html;
		$text[] = $this->params->get( 'title', 'Wire transfer' );

		return $text;
	}

	function onRenderPaymentInputOptions( $vars )
	{

		$vars->params = $this->params ;

		$html = $this->_getLayout('inputform', $vars);

		$text = array();
		$text[] = $html;
		$text[] = $this->params->get( 'title', 'Wire transfer' );

		return $text;
	}


	function onProcessPayment( $row, $user )
	{
		$ptype 		= JRequest::getVar( 'ptype' );
		if ($ptype == $this->_payment_type)
		{
			$paction 	= JRequest::getVar( 'paction' );
			$html = "";

			switch ($paction) {
				case "display_message":

				  break;
				case "process":

				  break;
				case "cancel":

				  break;
				default:

				  break;
			}

			return $html;
		}

	}

	function _getLayout($layout, $vars = false, $plugin = '', $group = 'affiliates')
	{
		if ( ! $plugin) {
			$plugin = $this->_payment_type;
		}

		ob_start();
        $layout = $this->_getLayoutPath( $plugin, $group, $layout );
        include($layout);
        $html = ob_get_contents();
        ob_end_clean();

		return $html;
	}


    function _getLayoutPath($plugin, $group, $layout = 'default')
    {
        $app = JFactory::getApplication();

        // get the template and default paths for the layout
        $templatePath = JPATH_SITE.DS.'templates'.DS.$app->getTemplate().DS.'html'.DS.'plugins'.DS.$group.DS.$plugin.DS.$plugin.DS.$layout.'.php';
        $defaultPath = JPATH_SITE.DS.'plugins'.DS.$group.DS.$plugin.DS.$plugin.DS.'tmpl'.DS.$layout.'.php';

        // if the site template has a layout override, use it
        jimport('joomla.filesystem.file');
        if (JFile::exists( $templatePath ))
        {
            return $templatePath;
        }
        else
        {
            return $defaultPath;
        }
    }


	function _getFormattedPaymentDetails($data)
	{
		$separator = "\n";
		$formatted = array();

		foreach ($data as $key => $value) {
			if ($key != 'view' && $key != 'layout' && $key != 'custom') {
				$formatted[] = $key . ' = ' . $value;
			}
		}

		return count($formatted) ? implode("\n", $formatted) : '';
	}

}
